//-----------------  ᯮ짮 zlib.dll
//쭮   㭪樨    ⮩ dll', ⮫쪮     ਬ. 
//   ᠭ 室  



extern WINAPI "zlib.dll"
{
//	int cdecl puts(char *);
//	void cdecl qsort();



DWORD stdcall  zlibVersion();
/* The application can compare zlibVersion and ZLIB_VERSION for consistency.
   If the first character differs, the library code actually used is
   not compatible with the zlib.h header file used by the application.
   This check is automatically made by deflateInit and inflateInit.
 */


DWORD stdcall unzOpen(char *path);
/*
  Open a Zip file. path contain the full pathname (by example,
     on a Windows NT computer "c:\\zlib\\zlib111.zip" or on an Unix computer
	 "zlib/zlib111.zip".
	 If the zipfile cannot be opened (file don't exist or in not valid), the
	   return value is NULL.
     Else, the return value is a unzFile Handle, usable with other function
	   of this unzip package.
*/


int stdcall unzClose(DWORD);
/*
  Close a ZipFile opened with unzipOpen.
  If there is files inside the .Zip opened with unzOpenCurrentFile (see later),
    these files MUST be closed with unzipCloseCurrentFile before call unzipClose.
  return UNZ_OK if there is no problem. */



int stdcall unzGetGlobalInfo(DWORD, DWORD);
/*
  Write info about the ZipFile in the *pglobal_info structure.
  No preparation of the structure is needed
  return UNZ_OK if there is no problem. */



//int stdcall unzGetCurrentFileInfo(DWORD, DWORD, char *szFileName, DWORD, DWORD, DWORD, char *szComment, DWORD);
int stdcall unzGetCurrentFileInfo(DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD);

/*
extern int ZEXPORT unzGetCurrentFileInfo OF((unzFile file,
					     unz_file_info *pfile_info,
					     char *szFileName,
					     uLong fileNameBufferSize,
					     void *extraField,
					     uLong extraFieldBufferSize,
					     char *szComment,
					     uLong commentBufferSize));
  Get Info about the current file
  if pfile_info!=NULL, the *pfile_info structure will contain somes info about
	    the current file
  if szFileName!=NULL, the filemane string will be copied in szFileName
			(fileNameBufferSize is the size of the buffer)
  if extraField!=NULL, the extra field information will be copied in extraField
			(extraFieldBufferSize is the size of the buffer).
			This is the Central-header version of the extra field
  if szComment!=NULL, the comment string of the file will be copied in szComment
			(commentBufferSize is the size of the buffer)
*/


int stdcall unzGoToNextFile(DWORD);
/*
  Set the current file of the zipfile to the next file.
  return UNZ_OK if there is no problem
  return UNZ_END_OF_LIST_OF_FILE if the actual file was the latest.
*/

int stdcall unzLocateFile(DWORD, DWORD, DWORD);
/*
int ZEXPORT unzLocateFile OF((unzFile file, 
				     const char *szFileName,
				     int iCaseSensitivity));

  Try locate the file szFileName in the zipfile.
  For the iCaseSensitivity signification, see unzStringFileNameCompare

  return value :
  UNZ_OK if the file is found. It becomes the current file.
  UNZ_END_OF_LIST_OF_FILE if the file is not found
*/


int stdcall unzOpenCurrentFile(DWORD);
/*
extern int ZEXPORT unzOpenCurrentFile OF((unzFile file));

  Open for reading data the current file in the zipfile.
  If there is no error, the return value is UNZ_OK.
*/


int stdcall unzReadCurrentFile(DWORD, DWORD, DWORD);
/*
extern int ZEXPORT unzReadCurrentFile OF((unzFile file, 
					  voidp buf,
					  unsigned len));

  Read bytes from the current file (opened by unzOpenCurrentFile)
  buf contain buffer where data must be copied
  len the size of buf.

  return the number of byte copied if somes bytes are copied
  return 0 if the end of file was reached
  return <0 with error code if there is an error
    (UNZ_ERRNO for IO error, or zLib error for uncompress error)
*/


int stdcall unzCloseCurrentFile(DWORD);
/*
extern int ZEXPORT unzCloseCurrentFile OF((unzFile file));

  Close the file in zip opened with unzOpenCurrentFile
  Return UNZ_CRCERROR if all the file was read but the CRC is not good
*/

/*

adler32.001
compress.002
compress2.039
crc32.003
deflate.004
deflateCopy.005
deflateEnd.006
deflateInit_.008
deflateInit2_.007
deflateParams.009
deflateReset.010
deflateSetDictionary.011
get_crc_table.038
gzclose.012
gzdopen.013
gzeof.034
gzerror.014
gzflush.015
gzgetc.030
gzgets.041
gzopen.016
gzprintf.028
gzputc.029
gzputs.040
gzread.017
gzrewind.032
gzseek.031
gzsetparams.035
gztell.033
gzwrite.018
inflate.019
inflateEnd.020
inflateInit_.022
inflateInit2_.021
inflateReset.023
inflateSetDictionary.024
inflateSync.025
inflateSyncPoint.037
NULL.042
NULL.043
NULL.044
NULL.045
NULL.046
NULL.047
NULL.048
NULL.049
NULL.050
NULL.051
NULL.052
NULL.053
NULL.054
NULL.055
NULL.056
NULL.057
NULL.058
NULL.059
NULL.060
NULL.069
NULL.079
NULL.085
uncompress.026
unzClose.062
unzCloseCurrentFile.072
unzeof.071
unzGetCurrentFileInfo.064
unzGetGlobalComment.073
unzGetGlobalInfo.063
unzGetLocalExtrafield.076
unzGoToFirstFile.065
unzGoToNextFile.066
unzLocateFile.075
unzOpen.061
unzOpen2.077
unzOpenCurrentFile.067
unzOpenCurrentFile2.078
unzReadCurrentFile.068
unzStringFileNameCompare.074
unztell.070
zError.036
zipClose.084
zipCloseFileInZip.083
zipCloseFileInZipRaw.087
zipOpen.080
zipOpenNewFileInZip.081
zipOpenNewFileInZip2.086
zipWriteInFileInZip.082
zlibVersion.027
*/

}



#define ZLIB_VERSION "1.1.4"


/* unz_global_info structure contain global data about the ZIPfile
   These data comes from the end of central dir */
struct unz_global_info
{
//	Long number_entry;         /* total number of entries in  the central dir on this disk */
unsigned long	number_entry;         /* total number of entries in  the central dir on this disk */	
//	Long size_comment;         /* size of the global comment of the zipfile */
unsigned long	size_comment;         /* size of the global comment of the zipfile */ 

};

struct fileinfo_t   
{
	char	name[256];
	DWORD	attr;
	DWORD	offset;
	DWORD	size;
	DWORD	c_offset;
};

struct packfile_t
{
	char			pak_name[256];
//	unzFile			uf;
        DWORD                   uf;
	unz_global_info		gi;

//	fileinfo_t		*fi;
	DWORD			fi;
};



/* tm_unz contain date/time info */

struct tm_unz 
{
	unsigned tm_sec;            /* seconds after the minute - [0,59] */
	unsigned tm_min;            /* minutes after the hour - [0,59] */
	unsigned tm_hour;           /* hours since midnight - [0,23] */
	unsigned tm_mday;           /* day of the month - [1,31] */
	unsigned tm_mon;            /* months since January - [0,11] */
	unsigned tm_year;           /* years - [1980..2044] */
};



/* unz_file_info contain information about a file in the zipfile */
struct unz_file_info
{
    dword version;              /* version made by                 2 bytes */
    dword version_needed;       /* version needed to extract       2 bytes */
    dword flag;                 /* general purpose bit flag        2 bytes */
    dword compression_method;   /* compression method              2 bytes */
    dword dosDate;              /* last mod file date in Dos fmt   4 bytes */
    dword crc;                  /* crc-32                          4 bytes */
    dword compressed_size;      /* compressed size                 4 bytes */ 
    dword uncompressed_size;    /* uncompressed size               4 bytes */ 
    dword size_filename;        /* filename length                 2 bytes */
    dword size_file_extra;      /* extra field length              2 bytes */
    dword size_file_comment;    /* file comment length             2 bytes */

    dword disk_num_start;       /* disk number start               2 bytes */
    dword internal_fa;          /* internal file attributes        2 bytes */
    dword external_fa;          /* external file attributes        4 bytes */

    tm_unz tmu_date;

//    dword offset, c_offset;
};
